UltraSquirt = LibStub("AceAddon-3.0"):NewAddon("UltraSquirt", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")

local USQ = UltraSquirt
USQ.DebugMode = nil

local L = LibStub("AceLocale-3.0"):GetLocale("UltraSquirt")

function USQ:OnInitialize()
    USQ.AwaitingOOC = false
    USQ:RegisterChatCommand("ultra", "SlashHandler")

    if USQ.Frame == nil then
        USQ.Frame = CreateFrame("Frame", "UltraSquirtFrame", UIParent)
    end
    USQ.Frame:Hide()
    USQ.Frame:ClearAllPoints()
    --USQ.Frame:SetPoint("CENTER", "UIParent", "CENTER")
    USQ.Frame:SetPoint("TOP", "UIParent", "TOP", 0, -150)
    USQ.Frame:SetWidth(300)
    USQ.Frame:SetHeight(100)
    USQ.Frame:SetFrameStrata("DIALOG")

    local TitleBG = USQ.Frame:CreateTexture("TitleBG", "BACKGROUND")
    TitleBG:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Title-Background")
    TitleBG:SetPoint("TOPLEFT", 9, -6)
    TitleBG:SetPoint("BOTTOMRIGHT", USQ.Frame, "TOPRIGHT", -28, -24)

    local DialogBG = USQ.Frame:CreateTexture("DialogBG", "BACKGROUND")
    DialogBG:SetTexture("Interface\\Tooltips\\UI-Tooltip-Background")
    DialogBG:SetPoint("TOPLEFT", 8, -24)
    DialogBG:SetPoint("BOTTOMRIGHT", -6, 8)
    DialogBG:SetColorTexture(0, 0, 0, .75)

    local TopLeft = USQ.Frame:CreateTexture("TopLeft", "BORDER")
    TopLeft:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    TopLeft:SetPoint("TOPLEFT")
    TopLeft:SetWidth(64)
    TopLeft:SetHeight(64)
    TopLeft:SetTexCoord(0.501953125, 0.625, 0, 1)

    local TopRight = USQ.Frame:CreateTexture("TopRight", "BORDER")
    TopRight:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    TopRight:SetPoint("TOPRIGHT")
    TopRight:SetWidth(64)
    TopRight:SetHeight(64)
    TopRight:SetTexCoord(0.625, 0.75, 0, 1)

    local Top = USQ.Frame:CreateTexture("Top", "BORDER")
    Top:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    Top:SetPoint("TOPLEFT", TopLeft, "TOPRIGHT")
    Top:SetPoint("TOPRIGHT", TopRight, "TOPLEFT")
    Top:SetWidth(0)
    Top:SetHeight(64)
    Top:SetTexCoord(0.25, 0.369140625, 0, 1)

    local BottomLeft = USQ.Frame:CreateTexture("BottomLeft", "BORDER")
    BottomLeft:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    BottomLeft:SetPoint("BOTTOMLEFT")
    BottomLeft:SetWidth(64)
    BottomLeft:SetHeight(64)
    BottomLeft:SetTexCoord(0.751953125, 0.875, 0, 1)

    local BottomRight = USQ.Frame:CreateTexture("BottomRight", "BORDER")
    BottomRight:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    BottomRight:SetPoint("BOTTOMRIGHT")
    BottomRight:SetWidth(64)
    BottomRight:SetHeight(64)
    BottomRight:SetTexCoord(0.875, 1, 0, 1)

    local Bottom = USQ.Frame:CreateTexture("Bottom", "BORDER")
    Bottom:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    Bottom:SetPoint("BOTTOMLEFT", BottomLeft, "BOTTOMRIGHT")
    Bottom:SetPoint("BOTTOMRIGHT", BottomRight, "BOTTOMLEFT")
    Bottom:SetWidth(0)
    Bottom:SetHeight(64)
    Bottom:SetTexCoord(0.376953125, 0.498046875, 0, 1)

    local Left = USQ.Frame:CreateTexture("Left", "BORDER")
    Left:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    Left:SetPoint("TOPLEFT", TopLeft, "BOTTOMLEFT")
    Left:SetPoint("BOTTOMLEFT", BottomLeft, "TOPLEFT")
    Left:SetWidth(64)
    Left:SetHeight(0)
    Left:SetTexCoord(0.001953125, 0.125, 0, 1)

    local Right = USQ.Frame:CreateTexture("Bottom", "BORDER")
    Right:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    Right:SetPoint("TOPRIGHT", TopRight, "BOTTOMRIGHT")
    Right:SetPoint("BOTTOMRIGHT", BottomRight, "TOPRIGHT")
    Right:SetWidth(64)
    Right:SetHeight(0)
    Right:SetTexCoord(0.1171875, 0.2421875, 0, 1)

    local CloseButton = CreateFrame("Button", "UltraSquirtCloseButton", USQ.Frame, "UIPanelCloseButton")
    CloseButton:SetPoint("TOPRIGHT", 2, 1)
    CloseButton:SetWidth(32)
    CloseButton:SetHeight(32)
    CloseButton:SetScript("OnClick", USQ.Close)

    local TitleButton = CreateFrame("Button", "TitleButton", USQ.Frame)
    TitleButton:SetPoint("TOPLEFT", TitleBG, "TOPLEFT")
    TitleButton:SetPoint("TOPRIGHT", TitleBG, "TOPRIGHT")
    TitleButton:SetWidth(375)
    TitleButton:SetHeight(16)
    
    local TitleButtonText = TitleButton:CreateFontString("Text", "OVERLAY", "GameFontNormal")
    TitleButtonText:SetPoint("TOPLEFT", TitleButton, "TOPLEFT")
    TitleButtonText:SetPoint("TOPRIGHT", TitleButton, "TOPRIGHT")
    TitleButtonText:SetWidth(375)
    TitleButtonText:SetHeight(16)
    TitleButtonText:SetText("UltraSquirt")

    USQ.Frame.MacroButton = CreateFrame("Button", "UltraSquirtButton", USQ.Frame, "InsecureActionButtonTemplate")
    USQ.Frame.MacroButton:SetAttribute("type1", "macro")

    USQ.Frame.MacroButton:SetText("Ultra")
    USQ.Frame.MacroButton:HookScript("OnClick", USQ.Update)
    USQ.Frame:SetScript("OnKeyDown", USQ.Update)
    USQ.Frame:SetPropagateKeyboardInput(true)
end

function USQ:OnEnable()
    USQ:Print("Addon enabled")
end

function USQ:OnDisable()
    USQ.Close()
    USQ:Print("Addon disabled")
end

function USQ.Debug(...)
    if USQ.DebugMode then
        USQ:Print(...)
    end
end

function USQ.SetMacro(macroText)
    if not InCombatLockdown() then
        USQ.Debug("Setting macro to " .. macroText)
        USQ.Frame.MacroButton:SetAttribute("macrotext1", macroText)
    end
end

function USQ.SlashHandler(input)
    if USQ.Frame:IsShown() then
        USQ.Close()
    else
        USQ.Open()
    end
end

function USQ.Close()
    SetCVar("AutoInteract", 0)
    ClearOverrideBindings(USQ.Frame)
    USQ:CancelAllTimers()
    USQ:UnregisterAllEvents()
    USQ.Frame:EnableKeyboard(false)
    USQ.Frame:Hide()
    USQ.Debug("Frame hidden")
end

function USQ.Open()
    USQ.Frame:Show()
    USQ.Debug("Frame shown")
    USQ:RegisterEvent("PET_BATTLE_OPENING_START")
    USQ:RegisterEvent("PET_BATTLE_OVER")
    USQ:RegisterEvent("PET_BATTLE_CLOSE")
    USQ:RegisterEvent("GOSSIP_SHOW")
    USQ:RegisterEvent("PLAYER_REGEN_DISABLED")
    USQ.Frame:EnableKeyboard(true)
    USQ.Update()
end

function USQ.EventHandler(eventName)
    USQ.Debug("Event: " .. (eventName or ""))
    if eventName == "PLAYER_REGEN_DISABLED" then
        USQ.Close()
    elseif (eventName == "PET_BATTLE_OPENING_START" or eventName == "PET_BATTLE_OVER" or "PET_BATTLE_CLOSE" or eventName == "PET_JOURNAL_LIST_UPDATE") then
        USQ.Update()
    else
        USQ.Debug("Unknown Event: " .. (eventName or ""))
    end
end

function USQ.Update()
    -- runs when registered events are triggered, after GOSSIP_OPEN is processed, on keypress while frame open, or when UltraSquirtButton is clicked
    USQ.Debug("Running Update")
    if InCombatLockdown() then
        USQ.Debug("In combat - take no action")
    else
        if C_PetBattles.IsInBattle() then
            USQ.Debug("In pet battle - setting hotkey to /click for TD Script auto button.  Disable IWT and CTM.")
            SetCVar("AutoInteract", 0)
            ClearOverrideBindings(USQ.Frame)
            SetOverrideBindingClick(USQ.Frame, true, "SPACE", "tdBattlePetScriptAutoButton")
        else
            USQ.Debug("Checking for pet damage")
            local npcID = USQ:TargetNPCID()
            if USQ:PetsHurt() then
                if (npcID == 85418 or npcID == 79858) then
                    USQ.Debug("Pets damaged, target is Stable Master.  Set button to IWT and enable CTM.")
                    SetCVar("AutoInteract", 1)
                    ClearOverrideBindings(USQ.Frame)
                    SetOverrideBinding(USQ.Frame, true, "SPACE", "INTERACTTARGET")
                else
                    USQ.Debug("Pets damaged, set macro to /target Stable Master.  Disable IWT and CTM.")
                    SetCVar("AutoInteract", 0)
                    ClearOverrideBindings(USQ.Frame)
                    USQ.SetMacro("/targetexact " .. L["Lio the Lioness"] .. "\n/targetexact " .. L["Serr'ah"])
                    SetOverrideBindingClick(USQ.Frame, true, "SPACE", "UltraSquirtButton")
                end
            else
                if (npcID == 79179) then --Squirt = 79179
                    USQ.Debug("Pets not damaged, target is Squirt.  Set button to IWT and enable CTM.")
                    SetCVar("AutoInteract", 1)
                    ClearOverrideBindings(USQ.Frame)
                    SetOverrideBinding(USQ.Frame, true, "SPACE", "INTERACTTARGET")
                else
                    USQ.Debug("Pets not damaged, set macro to /targetexact Squirt.  Disable IWT and CTM.")
                    SetCVar("AutoInteract", 0)
                    ClearOverrideBindings(USQ.Frame)
                    USQ.SetMacro("/targetexact " .. L["Squirt"])
                    SetOverrideBindingClick(USQ.Frame, true, "SPACE", "UltraSquirtButton")
                end
            end
        end
    end
end

function USQ:TargetNPCID()
    if UnitGUID("target") then
        return tonumber((select(6, strsplit("-", UnitGUID("target")))))
    end
end

function USQ:PetsHurt()
    local petsHurt = false
    for i = 1, 3 do
        local petGUID, ability1, ability2, ability3, locked = C_PetJournal.GetPetLoadOutInfo(i)
        petsHurt = (petsHurt or C_PetJournal.PetIsHurt(petGUID))
    end
    return petsHurt
end

function USQ:PET_BATTLE_OPENING_START(eventName)
    USQ.EventHandler(eventName)
end

function USQ:PET_BATTLE_OVER(eventName)
    USQ.EventHandler(eventName)
end

function USQ:PET_BATTLE_CLOSE(eventName)
    USQ.EventHandler(eventName)
end

function USQ:PET_JOURNAL_LIST_UPDATE(eventName)
    USQ.EventHandlet(eventName)
end

function USQ:GOSSIP_SHOW(eventName)
    USQ.Debug("GOSSIP_SHOW triggered.")
    for i = 1, GetNumGossipOptions() do
        local gossipText, gossipType = select(i * 2 - 1, GetGossipOptions())
        if gossipText == L["HealGossip"] then
            SelectGossipOption(i, "", true)
        end
    end
    USQ.Update()
end

function USQ:PLAYER_REGEN_DISABLED(eventName)
    USQ.EventHandler(eventName)
end